/* GRPACK2:
     ᪨ , ᯮ騩 ᪨ 㭪樨,
     㯭   ࡮  ᨨ 1.5.

      : Huge (  ᯮ㥬 㫥).

     ᯥ稢 ࠡ:
	       ७ ᪮  (EGA, 640 x 350)
               ⭮ ᪮  (CGA, 640 x 200)
               ᪮  㫥 (HGA, 720 x 348)

      GRPACK2 ।祭  ᯮ짮 ᮢ⭮
      㫥 DST  ନ஢ ᪨ ८
*/

#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <process.h>
#include <string.h>
#include <alloc.h>
#include <graphics.h>

void display(void),		/* ⮢ ଠ  㭪樨 DST	*/
     infopage(int i),
     nameprogr (void);
char mygetch(void);
void stereoeff(void);		/* ଠ  ८-䥪		*/

union REGS regs;

int in_textmode=1, X__max, Y__max, drawmode=1, adaptype;

				/*  ६ 	*/
extern double 	v11, v12, v13, v21, v22, v23, v32, v33, v43,
		r11, r12, r13, r21, r22, r23,
		r31, r32, r33, r41, r42, r43;

FILE *fplot=NULL;

float x_max=10.0, y_max=7.0, horfact, vertfact;

static int X1, Y1, foregroundcol, backgroundcol,
   g_driver, g_mode;

static long int startaddress;

void to_text(void);
void textXY(int X, int Y, char *str);

int IX(float x) { return (int)(x*horfact+0.5); }
int IY(float y) { return Y__max-(int)(y*vertfact+0.5); }

static void error(char *str)
     /* ⮡ࠦ ᮮ饭  믮 ணࠬ 蠥	*/

{ if (!in_textmode) to_text( );
  printf("%s\n", str); exit(1);
}

void clearpage(void)
				    /* ⪠ ࠭			*/
{ clearviewport( );
}

int iscolor(void)
			/* । ⨯ ᯮ㥬 	*/

{ detectgraph(&g_driver, &g_mode);
  if (g_mode == MCGAHI) g_mode = MCGAMED;
  if (g_mode == ATT400HI) g_mode = ATT400MED;
  if (g_mode == VGAHI) g_mode = VGAMED;
  return g_driver == CGA || g_driver == MCGA ||
	 g_driver == ATT400 ?
	   1 /* 640 x 200 */ :
	 g_driver == EGA || g_driver == EGA64 ||
	 g_driver == EGAMONO || g_driver == VGA ?
	   2 /* 640 x 350 */ :
	 g_driver == HERCMONO ? 0 /* 720 x 348 */ : -1;
}

static void setgrcon(int adaptype)
				/* ⠭ ᪨ ⠭	*/

{ startaddress = (adaptype == 2 ? 0xA0000000 : 0xB8000000);
  if (adaptype == 2)
  { X__max = 639; Y__max = 349;   /* EGA */
  } else
  if (adaptype == 1)
  { X__max = 639; Y__max = 199;   /* CGA */
  } else
  { X__max = 719; Y__max = 347;   /* HGA */
  }
}

static int grbrfun(void)
		/* ᯮ  㭪樨 'ctrlbrk'  ।	*/
		/* 権, 믮塞  ᮫쭮 뢠	*/

{ to_text( ); return 0;	/* 室  ⥪⮢ ० । 室 !	*/
}

void initgr(void)
				/* 樠 ᪮ ०	*/
{ static int again=0;
  int errcode;
  if (again) setgraphmode(g_mode); else
  { adaptype = iscolor( );	/* । ࠩ  ०	*/
    if (adaptype < 0) error (" ᯫ ");
    ctrlbrk(grbrfun);		/* ணࠬ 뢠  ࡮ 	*/
    initgraph(&g_driver, &g_mode, "\\turboc");
    errcode = graphresult( );
    if (errcode < 0)
    { printf (" 訡  ᪮ : %d", errcode); exit(1);
    }
    again = 1;
    setgrcon(adaptype);
  }
  horfact = X__max/x_max; vertfact = Y__max/y_max;
  if (adaptype == 0) /* HCG */
  { setvisualpage(1); setactivepage(1);
  }
  in_textmode=0;
  foregroundcol=getcolor( );
  backgroundcol=getbkcolor( );
}

static int txtbrfun(void)
{ return 0;
}

void to_text(void)			/*   ⥪⮢ ०	*/

{ if (!in_textmode) restorecrtmode( );
  in_textmode = 1;
  ctrlbrk(txtbrfun); /* ⠭ ࠡ⪨ 뢠  㬮砭 */
}

void endgr(void)
     /*       室  ⥪⮢ ०	*/

{ getch( );
  to_text( );
}

void dot(int X, int Y) 		    /* ᢥ⪠  襭 ᥫ	*/
{  int icol;   int fgcol;
       fgcol = getcolor( );
       icol = getpixel(X, Y);
       putpixel
	(X, Y,
	 (drawmode == 0 ? ( icol == foregroundcol ?
				    backgroundcol : foregroundcol )
			: ( drawmode == 1 ?
			  ( (fgcol == 9 && icol > 10) ? 13 : fgcol )
					  : backgroundcol
			  )
	  )     	/* drawmode =  1: 祭	*/
	);		/* drawmode = -1: ࠭	*/
}               	/* drawmode =  0: ४祭	*/

void checkbreak(void)

{ char ch;
  if (kbhit( )) { ch = getch( ); kbhit( ); ungetch(ch); }
}

void draw_line(int X1, int Y1, int X2, int Y2)
		/* 祭 १ אַ  (X1, Y1)  (X2, Y2),	*/
		/* 	 X1, Y1, X2, Y2  ᥫ न	*/
{ int X, Y, T, E, dX, dY, denom, Xinc = 1, Yinc = 1,
  vertlonger = 0, aux;
  checkbreak();		/* ⠭   ᮫쭮 뢠	*/
  if (in_textmode) error( "  ᪮ ० (㦥 맮 initgr)");
  dX = X2 - X1; dY = Y2 - Y1;
  if (dX < 0) {Xinc = -1; dX = -dX;}
  if (dY < 0) {Yinc = -1; dY = -dY;}
  if (dY > dX) { vertlonger = 1; aux = dX; dX = dY; dY = aux; }
  denom = dX << 1;
  T = dY << 1;
  E = -dX; X = X1;
  Y = Y1;
  if (vertlonger)
  while (dX-- >= 0)
  { dot(X, Y);
    if ((E += T) > 0)
    { X += Xinc; E -= denom;
    }
    Y += Yinc;
  } else
  while (dX-- >= 0)
  { dot(X, Y);
    if ((E += T) > 0)
    { Y += Yinc; E -= denom;
    }
    X += Xinc;
  }
  if (drawmode == 0) dot(X1, Y1);
}

static void fatal(void)
		/* 뢮      ,	*/
		/* ᫥ 祣 ⥫ 室  ⥪⮢ ०	*/

{ draw_line(0, Y__max,  X__max, 0); endgr( );
}

static void check(int X, int Y)
		/* ᫨ 窠 (X, Y)  ࠭ ࠭,  맮 㭪樨 */
		/* 'fatal', ⮡ࠦ ࠢ न  ⠭ */

{ if (X < 0 || X > X__max || Y < 0 || Y > Y__max)
  { fatal( );
    printf ("窠  ࠭ (X  Y  ᥫ न):\n");
    printf("X = %d       Y = %d\n", X, Y);
    printf("x = %10.3f   y = %10.3f\n", X/horfact, (Y__max-Y)/vertfact);
    printf("X__max = %d  Y__max = %d  x_max = %f y_max = %f\n",
	    X__max,      Y__max,      x_max,     y_max);
    printf("horfact = %f  vertfact = % f\n",
	    horfact,      vertfact);
    exit(1);
  }
}

void move(float x, float y)
	/* ७ ⥪饩 窨  (x, y); x  y  ࠭ न	*/

{ int XX, YY;
  XX = IX(x); YY = IY(y); check(XX, YY);
  if (fplot != NULL && (XX != X1 || YY != Y1))
    fprintf(fplot, "%6.3f %6.3f 0\n", x, y);
  X1 = XX; Y1 = YY;
}


void draw(float x, float y)
	/* 祭 १ אַ  ⥪饩 窨   (x, y)	*/

{ int X2, Y2;
  X2 = IX(x); Y2 = IY(y); check(X2, Y2);
  draw_line(X1, Y1, X2, Y2);
  if (fplot != NULL)
  fprintf(fplot, "%6.3f %6.3f 1\n", x, y);
  X1 = X2; Y1 = Y2;
}

int pixlit(int X, int Y)
	       /* ,  ᢥ祭  ᥫ (X, Y)		 */

{ return (getpixel(X, Y) == foregroundcol);
}

static void prchar(char ch)
			/* 뫪  ch  ࠫ  ਭ */

{ regs.x.dx=0;		/* 롮ઠ ਭ				*/
  regs.h.ah=0;		/* 뫪   AL  ਭ		*/
  regs.h.al=ch;		/*   뫪  ਭ			*/
  int86(0x17, &regs, &regs);
}

void printgr(int Xlo, int Xhi, int Ylo, int Yhi)
		/*   筮 ਭ ᮤন אַ㣮쭨 */

{ int n1, n2, ncols, i, X, Y, val, Xhi1;
  char line[720];		/* 720 >= X__max */
  regs.x.dx = 0;		/* LPT1          */
  regs.h.ah = 2;		/*  2: 롮ઠ ﭨ ਭ	*/
  int86(0x17, &regs, &regs);	/*  ਭ			*/
  if ((regs.h.ah & 8) == 8)	/* 뫪 ﭨ ਭ  AH	*/
  { if (in_textmode) printf(" ⥪⮢ ०"); else
    textXY(0, Y__max - 15,  "ਭ  ⮢");
    return;
  }
  prchar(27); prchar('1');	/*  ப 7/72 		*/
  for (i=Ylo; i<=Yhi; i+=7)
  { checkbreak( );		/* ஢ઠ ᮫쭮 뢠 	*/
    Xhi1 = Xlo-1;
    for (X=Xlo; X<=Xhi; X++)
    { val=0;
      for (Y=i; Y<i+7; Y++)
      { val <<= 1; val |= (Y>Yhi ? 0 : pixlit(X, Y));
      }
      line[X] = val;
      if (val) Xhi1 = X;
    }
    ncols = Xhi1-Xlo+1;
    if (ncols)
    { n1=ncols%256; n2=ncols/256;
      prchar(27); prchar('L'); prchar(n1); prchar(n2);
      for (X=Xlo; X<=Xhi1; X++) prchar(line[X]);
    }
    prchar('\n');
  }
  prchar(27); prchar('@');
}

void setprdim(void)
	/*  ⮩ 㭪樨 ⠭ ⠪ 祭 x_max  y_max,
	    ᪨ १ 㤥 뢥    ᮡ
	    ᮮ⭮襭 ࠧ஢  ਧ⠫   ⨪     */

{ extern float x_max, y_max;
  extern int X__max, Y__max;
  setgrcon(iscolor( ));
  x_max = (X__max + 1)/120.0; y_max=(Y__max + 1)/72.0;
}

void textXY(int X, int Y, char *str)
/* ⮡ࠦ ப str  ᪮ ०, 稭  窨 (X, Y) */

{ int height, width;
  height = textheight(str); width = textwidth(str);
  setviewport(X, Y, X+width, Y+height, 0);
  clearviewport( );		/* ࠭ ண ⥪, ᫨   */
  outtext(str);
  setviewport(0, 0, X__max, Y__max, 0);
}

void text(char *str)
	/* ⮡ࠦ ப str, 稭  ⥪饩 窨 (X1, Y1)	*/

{ textXY(X1, Y1, str);
  X1 += strlen(str) * 8;
  check(X1, Y1);
}

void imove(int X, int Y)
			/*  (X, Y) 㤥  ⥪饩 窮	*/

{ check(X, Y); X1=X; Y1=Y;
}

void idraw(int X, int Y)
	     /* 祭 १ אַ  ⥪饩 窨   (X, Y)	*/

{ check(X, Y);
  draw_line(X1, Y1, X, Y);
  X1=X; Y1=Y;
}

void wrscr(int row, int col, char *str)		/*  ⥪⮢ ०	*/
	/*   ᨬ   ᯫ  ⥪⮢ ०. */
	/*		row = 0, 1, ..., 24;  col = 0, 1, ..., 79	*/
{ gotoxy(col+1, row+1);
  cputs(str);
}

void clearscr(void)
	/*  ᯮ짮  ⥪⮢ ०.  		*/
	/*  㭪樥 'clearpage', ਬ塞  ᪮ ०.	*/

{ clrscr( );
}

void settxtcursor(int row, int col)
			/* ⠭   ⥪⮢ ०		*/
{ gotoxy(col+1, row+1);
}

void far * far _graphgetmem(unsigned size)
{ char *p;
  p = farmalloc((long)size);
  if (p == NULL) error (" 墠⠥   㭪樨 '_graphgetmem'");
  return p;
}

void far _graphfreemem(void far *ptr, unsigned size)
{ farfree(ptr);
}

void txtaspect(void)
			/* ⮢ ᮮ饭  㭪樨 'aspect'	*/

{ wrscr(8, 0,
    "᫥ ⮡ࠦ १  ࠭      ");
  wrscr(9, 0,
    "筮 ਭ ⥬   P.");
  wrscr(10, 0,
    "᫨  ⮣  㤥      㣠  ,   ");
  wrscr(11, 0, "࠭ ⠭ ।饥 ࠦ.");
  wrscr(12, 0,
    "㤥  ,   ᯮ 筮 ⭮襭 ஭, ᫨");
  wrscr(13, 0,
    "㦭 ࠦ  㦭,   .");
  wrscr(14, 0,
    "ଠ쭮 ⭮襭 ஭ 㤥   ࠭.");
  wrscr(15, 0,
    "᫨    ୮ ⭮襭 ஭  㦭 ᯥ   ਭ");
  wrscr(16, 0,
    "( ᪠ ୮ ⭮襭  ࠭), ,  ,");
  wrscr(17, 0,
    "   A.       O ,  ᫨ 室");
  wrscr(18, 0,
    " 室 䠩  (xxx.PLT),    ⥬    ,");
  wrscr(19, 0,
    "ਬ, ⠭ ணࠬ PLOTHP  ନ஢  ࠦ-");
  wrscr(20, 0,
  "       㣮 䮯ந⥫.");
  wrscr(21, 0,
  "᫨ 祣 ⮣  㦭,     ...");
}


void infopage(int i)
	/* ⮢ ᮮ饭    (  F1)	*/

{ if (i == 1)
  {
  clearscr();
  wrscr(0, 50, "࠭ 1 (ᥣ 3 ࠭)");
  wrscr(2, 0,
 "DST: ८-஥஢  嬥୮ ࠭⢥.  ..좮.");
  wrscr(3, 0, " (ࠡ⪠ ணࠬ   .ࠫ.");
  wrscr(4, 0,
  " ࠪ⨢ 嬥ୠ 設 䨪.-.:⥬, 1992.)");
  wrscr(6, 0,
 "     ணࠬ DST    ନ஢  ॠ  ࠦ");
  wrscr(7, 0,
 "嬥  '⮢.  ⥩訩  ᯮᮡ 砥  ᯮ짮");
  wrscr(8, 0,
 "䠩,  ⮢  ணࠬ   㣨  ᯮᮡ.");
  wrscr(9, 0,
 "஬  ⮣     室 䠩  । 窨 -");
  wrscr(10, 0,
 "⥫쭮,  ᯮ   I,   ।⢥   -");
  wrscr(11, 0,
 "  .   ࢮ 砥 ᫥  I 㦭  -");
  wrscr(12, 0,
 "⥫쭮 楫 ᫮  ⥬  嬥  न  x,  y,  z  ");
  wrscr(13, 0,
 "窨.    ஬  砥   । 樨 窨 ਬ");
  wrscr(14, 0,
 ".   ⮣ ᫥      X, Y, Z, ⥬ ");
  wrscr(15, 0,
 "+    -  ६饭 .   ࠢ   I");
  wrscr(16, 0,
 "  ,    J 뢠 室   ");
  wrscr(17, 0,
 " .   S   蠣 ६饭 -");
  wrscr(18, 0,
 ".   ⮡ࠦ 祭 न 窨 㦭    ");
  wrscr(19, 0,
 "।騬  ⥫   (?).   D  㤠");
  wrscr(20, 0,
 " 窨  ࠬ   .  ०   D");
  wrscr(21, 0,
 "㤠 ⮫쪮  ,  ࠭   J.   M ");
  wrscr(22, 0,
 "० 뢮 ஢ 祪, ᥩ,  ஥஢, ࠢ ⮫-");
  wrscr(23, 0,
 "騭   ࠧ஬ ࠭.                                       ");
 } else
  if (i == 2)
  {
  clearscr();
  wrscr(0, 50, "࠭ 2 (ᥣ 3 ࠭)");
  wrscr(1, 0,
 "     ᫥  ᪮쪨 祪      F  ।-");
  wrscr(2, 0,
 "  ࠭    १  ,  㪠 ᯨ᮪ ஢");
  wrscr(3, 0,
 "祪,  稢  ᨬ 窨 (.).  ਬ:                  ");
  wrscr(4, 0,"       F");
  wrscr(5, 0,"       1 2 3 4 5.");
  wrscr(6, 0,
 "     ᫨ ᫥  F  ,  祬  窨,   -");
  wrscr(7, 0,
 "砥,    設       ");
  wrscr(8, 0,
 " ᪮ ( .  ⠪  R ).  ᫥  H (. )");
  wrscr(9, 0,
 "   믮 ஫ ࠭ 嬥୮ '. 設");
  wrscr(10, 0,
 "    浪 室 ⨢ ᮢ ५ (  -");
  wrscr(11, 0,
 "  ' ). 訡   F   ᪮४஢-");
  wrscr(12, 0,
 "        L.    R 믮 뢠 ᠭ");
  wrscr(13, 0,
 "'  䠩,     W ' 뢠  䠩. -");
  wrscr(14, 0,
 "    窨  ७ 믮  V.  ⮬᪮");
  wrscr(15, 0,
 "㤠   ந室    H.   ");
  wrscr(16, 0,
 "訢  'ண' 祭  0  ᥤ ࠭ ( ");
  wrscr(17, 0,
 "७ 㣫   180 ࠤᠬ)  பᨬ஢  -");
  wrscr(18, 0,
 " 孮.  祭  ᥤ ࠭ 稢");
  wrscr(19, 0,
 "⮫쪮  ⮬ 砥,  ᫨ 㣮     ࠬ  ଠ  㤥");
  wrscr(20, 0,
 " 'ண' 祭.   E  뢮 ࠦ -");
  wrscr(21, 0,
 "  ࠭.   E  H  뢮  ࠦ");
  wrscr(22, 0,
 "  ਭ   .                                   ");
  }
  else
  if (i == 3)
  {
  clearscr();
  wrscr(0, 50, "࠭ 3 (ᥣ 3 ࠭)");
  wrscr(1, 0,
 "        䠩   EXAMPLE1.DAT  ..,  -");
  wrscr(2, 0,
 "뢠  '' 䠩', 뢠   W  -");
  wrscr(3, 0,
 "뢠   R. 砫  न  祪  ଠ");
  wrscr(4, 0,
 "'n x y z',   n -  窨.   ᫥ 祢 ᫮");
  wrscr(5, 0,
 "'Faces:' (࠭),  ᫥ 祣  ᯨ᮪ ᫥⥫쭮⥩ ஢");
  wrscr(6, 0,
 "祪  (.  ⠪  F).   ᫥⥫쭮 蠥");
  wrscr(7, 0,
 "窮 (.)  ᨬ #. 窨   ᫥⥫쭮 ");
  wrscr(8, 0,
 "設 ,  믮 ஫ ࠭ ' ᫥  -");
  wrscr(9, 0,
 " H.  ஭ ⠪  稢   ,  ");
  wrscr(10, 0,
 "᪫祭 ⥫ ஢ 祪.  ਬ,  '8 3 -5 2 7.'");
  wrscr(11, 0,
 "஭ 3 5  㤥 祭   . ᫥⥫쭮");
  wrscr(12, 0,
 "⮫쪮    祪 砥 ⤥ १ אַ .  -");
  wrscr(13, 0,
 " T ।   ८ࠧ,  : , -");
  wrscr(14, 0,
 "७, ⠡஢  ࠦ.  砫 ४ ᯮ-");
  wrscr(15, 0,
 "    R     ⥭   饣   䠩,   ਬ,");
  wrscr(16, 0,
 "EXAMPLE1.DAT;  ⥬ ஡   V   窨");
  wrscr(17, 0,
 "   E  뢮 ࠦ   ࠭. ");
  wrscr(18, 0,
 "४  ਬ  H  㤠  . ᫨");
  wrscr(19, 0,
 "᫥ ⮣     ⨭ ᠬ⥫쭮,");
  wrscr(20, 0,
 " ।⥫쭮 㦭  ࠭    C.          ");
 }
}

void helpinfo(void)
	/* ࠡ⪠   (  F1)	*/


{ int i=1, was_in_grmode;
  was_in_grmode = !in_textmode; /*    ६  */
  settxtcursor(24, 37);
  if (was_in_grmode)  { clearpage(); to_text();}
  do
  { infopage(i);
    if (i == 1)
    wrscr(24, 0,
	  "    த ...");
	else
    { wrscr(23, 0,
    "  '५ '    । -");
      wrscr(24, 0,
     ",      த ...");
    }
    if (mygetch() == 0 && mygetch() == 72)
    { if (--i == 0) i = 1;
    } else i++;
  } while (i < 4);
  if (was_in_grmode)
  { initgr(); display();
  }
}

void menutext ( int margin, int typadap )
				/* 뢮     㭪樨	*/
{
    textXY(margin, 5,   "ணࠬ DST-८");
    textXY(margin, typadap*22,  "㯭  :");
    textXY(margin, typadap*40,  "X/Y/Z: ࠢ.஬");
    textXY(margin, typadap*54,  "?: 祭 न");
    textXY(margin, typadap*68,  "M-० (A-  ..)");
    textXY(margin, typadap*82,  "F1()| Q-室");
    textXY(margin, typadap*96,  "S-蠣     | C-");
    textXY(margin, typadap*110, "I-    | D-㤠");
    textXY(margin, typadap*124, "F-࠭   | L-ᯨ᮪");
    textXY(margin, typadap*138, "R-⥭  | W-");
    textXY(margin, typadap*152, "E- | H-");
    textXY(margin, typadap*166, "V-.७| T-८p.");
    textXY(margin, typadap*180, "O-८  ( U-.)");
}

void nameprogr (void)
					/* 뢮  ᮮ饭	*/

{ wrscr(2,10, "              ଠ ""SOL SYSTEM""    ");
  wrscr(3,10, " (᪢ 103104, / 38, ⥫. (095) 2-026-026)");
  wrscr(5,10, "            ।⠢ ணࠬ");
  wrscr(7,10, "'-   '");
  wrscr(8,10, "     ( ᪨ ८ࠦﬨ)");
  wrscr(10,10,"   ⢥ ⥫쭮 ਠ  :");
  wrscr(12,10,"  Ammeraal L., INTERACTIVE 3D COMPUTER GRAPHICS,");
  wrscr(13, 4,
   "   ,-.,'⥬', 1992");
}

void stereoeff(void)
				/* ଠ  ८-䥪		*/
{   extern int stereoi;
int p0[30]=
{ 80, 220,   80, 310,  240, 310,  270, 270, 270, 260,  275, 255,
 285, 255,  290, 260,  290, 270,  320, 310, 520, 310,  520, 220 };
int p1[10]={ 120, 235,  120, 295,  205, 295, 230, 270,  230, 235 };
int p2[10]={ 440, 235,  440, 295,  355, 295, 330, 270,  330, 235 };

	settextstyle(DEFAULT_FONT, HORIZ_DIR, 2);
	outtextxy( 36, 30, " 祭");
	outtextxy( 36, 180, "㦭 ᭮/ᨭ 窨");
	settextstyle(DEFAULT_FONT, HORIZ_DIR, 3);
	setcolor(12);
	outtextxy( 36, 80, "");
	setcolor(9);
	outtextxy( 130, 120, "");
	setcolor(15);
	settextstyle(DEFAULT_FONT, HORIZ_DIR, 1);
	outtextxy( 360, 320, " ");

	setfillstyle (INTERLEAVE_FILL, 15);
	fillpoly (12, p0);
	setfillstyle (SOLID_FILL, 12);
	fillpoly ( 5, p1);
	setfillstyle (SOLID_FILL,  9);
	fillpoly ( 5, p2);
	setcolor(getmaxcolor( ) );
	outtextxy(10, 340, " த   .... ");
	getch();
	clearpage();
}

